"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.$json = exports.$fusion = exports.$includesdict = exports.$dict = exports.$partial = exports.$keys = exports.$jsonobj = exports.$lengthin = exports.$lse = exports.$length = exports.$count = exports.$capacityForCount = exports.$totype = exports.$strings = exports.$array = exports.$string = exports.$tounsigned = exports.$toint = exports.$unsigned = exports.$unsignedornull = exports.$address = exports.$isodate = exports.$UUID = exports.$url = exports.$email = exports.$int = exports.$intornull = exports.$hasproperties = exports.$ismethod = exports.$isproperty = exports.$isfunction = exports.$isuuid = exports.$isurl = exports.$isemail = exports.$isdate = exports.$isiterable = exports.$isarray = exports.$objectcount = exports.$isobject = exports.$isbool = exports.$isunsigned = exports.$isint = exports.$isnumber = exports.$iswhitespace = exports.$isstring = exports.$valueorundefine = exports.$valueornull = exports.$value = exports.$ok = exports.$defined = void 0;
exports.$encoding = void 0;
const compare_1 = require("./compare");
const string_tables_1 = require("./string_tables");
const tsdatecomp_1 = require("./tsdatecomp");
const tsdefaults_1 = require("./tsdefaults");
const types_1 = require("./types");
const tsdate_1 = require("./tsdate");
const strings_1 = require("./strings");
const number_1 = require("./number");
const tserrors_1 = require("./tserrors");
function $defined(o) { return o !== undefined && typeof o !== 'undefined'; }
exports.$defined = $defined;
function $ok(o) { return o !== null && o !== undefined && typeof o !== 'undefined'; }
exports.$ok = $ok;
function $value(o, v) { return $ok(o) ? o : v; }
exports.$value = $value;
function $valueornull(o) { return $ok(o) ? o : null; }
exports.$valueornull = $valueornull;
function $valueorundefine(o) { return $ok(o) ? o : undefined; }
exports.$valueorundefine = $valueorundefine;
function $isstring(o) { return typeof o === 'string'; }
exports.$isstring = $isstring;
function $iswhitespace(s) { return $isstring(s) ? string_tables_1.FoundationWhiteSpacesStringCodeSet.has(s) : ($ok(s) ? string_tables_1.FoundationWhiteSpacesNumberCodeSet.has(s) : false); }
exports.$iswhitespace = $iswhitespace;
function $isnumber(o) { return typeof o === 'number' && !isNaN(o) && isFinite(o); }
exports.$isnumber = $isnumber;
function $isint(o) { return typeof o === 'number' && Number.isSafeInteger(o) && o >= types_1.INT_MIN && o <= types_1.INT_MAX; }
exports.$isint = $isint;
function $isunsigned(o, maximum = types_1.UINT_MAX) { return typeof o === 'number' && Number.isSafeInteger(o) && o >= 0 && o <= maximum; }
exports.$isunsigned = $isunsigned;
function $isbool(o) { return typeof o === 'boolean'; }
exports.$isbool = $isbool;
function $isobject(o) { return $ok(o) && typeof o === 'object'; }
exports.$isobject = $isobject;
function $objectcount(o) { return $isobject(o) ? $keys(o).length : 0; }
exports.$objectcount = $objectcount;
function $isarray(o) { return Array.isArray(o); }
exports.$isarray = $isarray;
function $isiterable(o) { return $isarray(o) || $ismethod(o, Symbol.iterator); }
exports.$isiterable = $isiterable;
function $isdate(o) { return (o instanceof Date || o instanceof tsdate_1.TSDate || $isstring(o)) && $ok($isodate(o)); }
exports.$isdate = $isdate;
function $isemail(o) { return $isstring(o) && $ok($email(o)); }
exports.$isemail = $isemail;
function $isurl(o, opts) { return o instanceof URL || ($isstring(o) && $ok($url(o, opts))); }
exports.$isurl = $isurl;
function $isuuid(o) { return $isstring(o) && $ok($UUID(o)); }
exports.$isuuid = $isuuid;
function $isfunction(o) { return typeof o === 'function'; }
exports.$isfunction = $isfunction;
function $isproperty(obj, prop) { return prop.length > 0 && $isobject(obj) && (prop in obj); }
exports.$isproperty = $isproperty;
function $ismethod(obj, meth) { return (typeof meth === 'symbol' || $length(meth) > 0) && $ok(obj) && $isfunction(obj[meth]); }
exports.$ismethod = $ismethod;
function $hasproperties(obj, properties) {
    if (!$isobject(obj) || !$count(properties)) {
        return false;
    }
    for (let p of properties) {
        if (!p.length || !(p in obj))
            return false;
    }
    return true;
}
exports.$hasproperties = $hasproperties;
function $intornull(n) {
    if (!$ok(n)) {
        return null;
    }
    if ($isstring(n)) {
        n = parseInt(n, 10);
    }
    return $isint(n) ? n : null;
}
exports.$intornull = $intornull;
function $int(n, defaultValue = 0) { return $value($intornull(n), defaultValue); }
exports.$int = $int;
function $email(s) {
    const m = _regexvalidatedstring(types_1.emailRegex, s);
    return $ok(m) ? m.toLowerCase() : null;
}
exports.$email = $email;
function $url(s, opts = {}) {
    if (!$length(s)) {
        return null;
    }
    const m = s.match(types_1.urlRegex);
    if ((m === null || m === void 0 ? void 0 : m.length) !== 2) {
        return null;
    }
    if ($ok(m[1])) {
        const protocol = m[1].toLowerCase();
        if (!protocol.length) {
            return null;
        }
        if ($count(opts.acceptedProtocols)) {
            return $ok(opts.acceptedProtocols.find(v => v.toLowerCase() === protocol)) ? s : null;
        }
        return protocol === 'http' || protocol === 'https' ? s : null;
    }
    return m[1] !== null && opts.acceptsProtocolRelativeUrl ? s : null;
}
exports.$url = $url;
function $UUID(s) {
    if (!$isstring(s)) {
        return null;
    }
    return _regexvalidatedstring(types_1.uuidRegex, s);
}
exports.$UUID = $UUID;
function $isodate(s, format = tsdatecomp_1.TSDateForm.ISO8601) {
    let cps = null;
    if ($ok(s)) {
        if (s instanceof Date) {
            cps = (0, tsdatecomp_1.$components)(s);
        }
        else if (s instanceof tsdate_1.TSDate) {
            cps = s.toComponents();
        }
        else if ($isstring(s)) {
            cps = (0, tsdatecomp_1.$parsedatetime)((0, strings_1.$ftrim)(s), format);
        }
    }
    return $ok(cps) ? (0, tsdatecomp_1.$components2string)(cps, format) : null;
}
exports.$isodate = $isodate;
function $address(a) {
    if (!$isobject(a)) {
        return null;
    }
    const city = (0, strings_1.$ftrim)(a === null || a === void 0 ? void 0 : a.city);
    const country = (0, tsdefaults_1.$country)(a === null || a === void 0 ? void 0 : a.country);
    if (!$isstring(city) || !$length(city) || !$ok(country)) {
        return null;
    }
    let ret = Object.assign({}, a);
    ret.city = city;
    ret.country = country;
    return ret;
}
exports.$address = $address;
function $unsignedornull(n) {
    if (!$ok(n)) {
        return null;
    }
    if ($isstring(n)) {
        n = parseInt(n, 10);
    }
    return $isunsigned(n) ? n : null;
}
exports.$unsignedornull = $unsignedornull;
function $unsigned(v, defaultValue = 0) { return $value($unsignedornull(v), defaultValue); }
exports.$unsigned = $unsigned;
function $toint(v, defaultValue = 0) {
    if (!$ok(v)) {
        return defaultValue;
    }
    if ($isstring(v)) {
        v = parseInt(v, 10);
    }
    return isNaN(v) ? defaultValue : Math.max(types_1.INT_MIN, (0, number_1.$icast)(Math.min(v, types_1.INT_MAX)));
}
exports.$toint = $toint;
function $tounsigned(v, defaultValue = 0) {
    if (!$ok(v)) {
        return defaultValue;
    }
    if ($isstring(v)) {
        v = parseInt(v, 10);
    }
    return isNaN(v) ? defaultValue : Math.max(types_1.UINT_MIN, (0, number_1.$icast)(Math.min(v, types_1.UINT_MAX)));
}
exports.$tounsigned = $tounsigned;
function $string(v) {
    if ($isstring(v)) {
        return v;
    }
    else if ($ismethod(v, 'toString')) {
        return v.toString();
    }
    else {
        return $ok(v) ? `${v}` : '';
    }
}
exports.$string = $string;
function $array(...values) { return values; }
exports.$array = $array;
function $strings(...values) {
    switch (values.length) {
        case 0:
            return [];
        case 1:
            return $isstring(values[0]) ? values : ($isarray(values[0]) ? values[0] : []);
        default: {
            const ret = [];
            values.forEach(v => {
                if ($isstring(v)) {
                    ret.push(v);
                }
                else if ($isarray(v)) {
                    v.forEach(s => ret.push(s));
                }
            });
            return ret;
        }
    }
}
exports.$strings = $strings;
function $totype(v) { return $ok(v) ? v : null; }
exports.$totype = $totype;
function $capacityForCount(count) {
    count = count <= 0 ? 0 : Math.ceil(count);
    return (count < 128 ? __capacitiesForCounts[count] : ((count + (count >> 1)) & ~255) + 256);
}
exports.$capacityForCount = $capacityForCount;
function $count(a) { return $ok(a) ? a.length : 0; }
exports.$count = $count;
function $length(s) { return $ok(s) ? s.length : 0; }
exports.$length = $length;
function $lse(s, start, end) {
    if (!$ok(s)) {
        return [0, 0, 0, 0];
    }
    const len = s.length;
    start = $tounsigned(start);
    end = Math.min($tounsigned(end, len), len);
    return [len, start, end, Math.max(end - start, 0)];
}
exports.$lse = $lse;
function $lengthin(s, min = 0, max = types_1.INT_MAX) { const l = $length(s); return l >= min && l <= max; }
exports.$lengthin = $lengthin;
function $jsonobj(v) {
    if (!$ok(v)) {
        return v;
    }
    if ($ismethod(v, 'toJSON')) {
        return v.toJSON();
    }
    switch (typeof v) {
        case 'object':
        case 'boolean':
        case 'number':
        case 'bigint':
        case 'string':
            return v;
        default:
            return undefined;
    }
}
exports.$jsonobj = $jsonobj;
function $keys(o) { return $ok(o) ? Object.getOwnPropertyNames(o) : []; }
exports.$keys = $keys;
function $partial(a, opts = {}) {
    let ret = {};
    let n = 0;
    if ($ok(a)) {
        n = _fillObject('partial', ret, a, opts);
    }
    return [ret, n];
}
exports.$partial = $partial;
function $dict(source, keys) {
    const ret = {};
    if ($ok(source)) {
        _fillObject('dict', ret, source, { properties: keys });
    }
    return ret;
}
exports.$dict = $dict;
function $includesdict(source, dict, keys) {
    if ($ok(source)) {
        keys = $ok(keys) ? keys : $keys(dict);
        if (keys.length) {
            const v = source;
            for (let k of keys) {
                if (!(0, compare_1.$equal)(v[k], dict[k])) {
                    return false;
                }
            }
            return true;
        }
    }
    return false;
}
exports.$includesdict = $includesdict;
function $fusion(a, b, opts = {}) {
    if (!$ok(a)) {
        return $ok(b) ? $partial(b, opts.B) : [{}, 0];
    }
    else if (!$ok(b)) {
        return $partial(a, opts.A);
    }
    let [ret, n] = $partial(a, opts.A);
    let fopts = $ok(opts.B) ? Object.assign({}, opts.B) : {};
    if ($ok(opts.fusionArrays)) {
        fopts.fusionArrays = opts.fusionArrays;
    }
    if ($ok(opts.fusionObjects)) {
        fopts.fusionObjects = opts.fusionObjects;
    }
    n += _fillObject('fusion', ret, b, fopts);
    return [ret, n];
}
exports.$fusion = $fusion;
function $json(v, replacer = null, space = 2) { return JSON.stringify(v, replacer, space); }
exports.$json = $json;
function $encoding(e) {
    if ($length(e) === 0 || e === 'utf8') {
        return 'utf8';
    }
    return $value(string_tables_1.FoundationStringEncodingsMap.get(e), 'utf8');
}
exports.$encoding = $encoding;
function _regexvalidatedstring(regex, s) {
    const v = (0, strings_1.$ftrim)(s);
    if (!v.length || !regex.test(v)) {
        return null;
    }
    return v;
}
function _fillObject(fn, destination, source, opts = {}) {
    let ret = 0;
    opts = Object.assign({}, opts);
    opts.properties = $ok(opts.properties) ? opts.properties : $keys(source);
    if (opts.properties.length) {
        const fusion_arrays = $isfunction(opts.fusionArrays);
        const fusion_objects = $isfunction(opts.fusionObjects);
        opts.filter = $isfunction(opts.filter) ? opts.filter : (v) => $ok(v) && typeof v !== 'function' ? v : undefined;
        for (let p of opts.properties) {
            if (!$isstring(p)) {
                throw new tserrors_1.TSError(`${fn}() needs to have valid string properties`, { function: fn, source: source, destination: destination, options: opts });
            }
            const v = opts.filter(source[p]);
            if ($defined(v)) {
                if (fusion_arrays && $isarray(v) && $isarray(destination[p])) {
                    destination[p] = opts.fusionArrays(destination[p], v);
                }
                else if (fusion_objects && $isobject(v) && $isobject(destination[p])) {
                    destination[p] = opts.fusionObjects(destination[p], v);
                }
                else {
                    destination[p] = v;
                }
                ret++;
            }
        }
    }
    return ret;
}
const __capacitiesForCounts = [
    2, 2, 4, 4, 8, 8, 8, 8,
    16, 16, 16, 16, 16, 16, 16, 16,
    32, 32, 32, 32, 32, 32, 32, 32,
    32, 32, 32, 32, 32, 32, 32, 32,
    64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64,
    64, 64, 64, 64, 64, 64, 64, 64,
    128, 128, 128, 128, 128, 128, 128, 128,
    128, 128, 128, 128, 128, 128, 128, 128,
    128, 128, 128, 128, 128, 128, 128, 128,
    128, 128, 128, 128, 128, 128, 128, 128,
    128, 128, 128, 128, 128, 128, 128, 128,
    128, 128, 128, 128, 128, 128, 128, 128,
    256, 256, 256, 256, 256, 256, 256, 256,
    256, 256, 256, 256, 256, 256, 256, 256,
    256, 256, 256, 256, 256, 256, 256, 256
];
//# sourceMappingURL=commons.js.map