"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.$password = exports.$random = exports.$hashfile = exports.$hash = exports.$decrypt = exports.$crc32 = exports.$encrypt = exports.HashMethod = exports.$uuid = void 0;
const crypto = __importStar(require("crypto"));
const fs_1 = require("fs");
const commons_1 = require("./commons");
const data_1 = require("./data");
const tscharset_1 = require("./tscharset");
const tsdata_1 = require("./tsdata");
const utils_1 = require("./utils");
function $uuid() {
    try {
        return crypto.randomUUID();
    }
    catch (_a) {
        (0, utils_1.$logterm)('Warning:crypto.randomUUID() is not available');
        let uuid = "";
        for (let i = 0; i < 32; i++) {
            const rand = Math.random() * 16 | 0;
            if (i == 8 || i == 12 || i == 16 || i == 20) {
                uuid += '-';
            }
            uuid += (i == 12 ? 4 : (i == 16 ? (rand & 3 | 8) : rand)).toString(16);
        }
        return uuid;
    }
}
exports.$uuid = $uuid;
var HashMethod;
(function (HashMethod) {
    HashMethod["SHA256"] = "SHA256";
    HashMethod["SHA384"] = "SHA384";
    HashMethod["SHA512"] = "SHA512";
})(HashMethod = exports.HashMethod || (exports.HashMethod = {}));
;
function $encrypt(ssource, skey, opts) {
    const [charset, key] = _charsetAndKey(skey, opts);
    if (!charset) {
        return null;
    }
    const source = (0, commons_1.$isstring)(ssource) ? charset.uint8ArrayFromString(ssource) : (0, data_1.$uint8ArrayFromDataLike)(ssource);
    if (!(0, commons_1.$length)(source)) {
        return null;
    }
    let returnValue = null;
    try {
        let iv = crypto.randomBytes(16);
        let cipher = crypto.createCipheriv('aes-256-cbc', key, iv);
        let encrypted = cipher.update(source);
        encrypted = Buffer.concat([encrypted, cipher.final()]);
        returnValue = iv.toString('hex') + encrypted.toString('hex');
    }
    catch (e) {
        returnValue = null;
    }
    return returnValue;
}
exports.$encrypt = $encrypt;
const __crcTable = (function __buildCRCTable() {
    var ret = [];
    for (let n = 0; n < 256; n++) {
        let crc = n;
        for (let i = 0; i < 8; i++) {
            crc = ((crc & 1) ? (0xedb88320 ^ (crc >>> 1)) : (crc >>> 1));
        }
        ret[n] = crc;
    }
    return ret;
})();
function $crc32(ssource, encoding) {
    const source = (0, commons_1.$isstring)(ssource) ?
        (0, tscharset_1.$charset)(encoding, tscharset_1.TSCharset.binaryCharset()).uint8ArrayFromString(ssource) :
        (0, data_1.$uint8ArrayFromDataLike)(ssource);
    let crc = 0 ^ -1;
    const len = source.length;
    for (let i = 0; i < len; i++) {
        crc = ((crc >> 8) & 0x00ffffff) ^ __crcTable[(crc ^ source[i]) & 0xff];
    }
    return (crc ^ -1) >>> 0;
}
exports.$crc32 = $crc32;
function $decrypt(source, skey, opts) {
    if (!(0, commons_1.$length)(source)) {
        return null;
    }
    const [charset, key] = _charsetAndKey(skey, opts);
    if (!charset) {
        return null;
    }
    let returnValue = null;
    try {
        let iv = Buffer.from(source.slice(0, 32), 'hex');
        let encryptedText = Buffer.from(source.slice(32), 'hex');
        let decipher = crypto.createDecipheriv('aes-256-cbc', key, iv);
        let decrypted = new tsdata_1.TSData(decipher.update(encryptedText));
        decrypted.appendBytes(decipher.final());
        returnValue = !(opts === null || opts === void 0 ? void 0 : opts.dataOutput) ? decrypted.toString(charset) : decrypted;
    }
    catch (e) {
        returnValue = null;
    }
    return returnValue;
}
exports.$decrypt = $decrypt;
function _charsetAndKey(skey, opts) {
    const charset = (0, tscharset_1.$charset)(opts === null || opts === void 0 ? void 0 : opts.encoding, tscharset_1.TSCharset.binaryCharset());
    const isKeyObject = skey instanceof crypto.KeyObject;
    let key = isKeyObject ?
        skey :
        ((0, commons_1.$isstring)(skey) ?
            charset.uint8ArrayFromString(skey) :
            (0, data_1.$uint8ArrayFromDataLike)(skey));
    if (!isKeyObject && key.length !== 32) {
        return [null, key];
    }
    return [charset, key];
}
function $hash(buf, method, encoding) {
    let ret = null;
    try {
        const source = (0, commons_1.$isstring)(buf) ?
            (0, tscharset_1.$charset)(encoding, tscharset_1.TSCharset.binaryCharset()).uint8ArrayFromString(buf) :
            (0, data_1.$uint8ArrayFromDataLike)(buf);
        let hash = crypto.createHash((0, commons_1.$length)(method) ? method.toLowerCase() : 'sha256');
        hash.update(source);
        ret = hash.digest('hex');
    }
    catch (e) {
        ret = null;
    }
    return ret;
}
exports.$hash = $hash;
function $hashfile(filePath, method) {
    return __awaiter(this, void 0, void 0, function* () {
        return new Promise((resolve, reject) => {
            let hash = crypto.createHash((0, commons_1.$length)(method) ? method.toLowerCase() : 'sha256');
            if (!(0, commons_1.$length)(filePath)) {
                return reject(null);
            }
            try {
                (0, fs_1.createReadStream)(filePath).on('data', data => hash.update(data)).on('end', () => resolve(hash.digest('hex')));
            }
            catch (e) {
                return reject(null);
            }
        });
    });
}
exports.$hashfile = $hashfile;
;
function $random(max) {
    return Math.floor(Math.random() * Math.floor(max));
}
exports.$random = $random;
function $password(len, opts = { hasLowercase: true }) {
    const MAX_CONSECUTIVE_CHARS = 2;
    if (!opts.hasLowercase && !opts.hasNumeric && !opts.hasSpecials && !opts.hasUppercase) {
        opts.hasUppercase = true;
    }
    if (len < 3 || len > 256)
        return null;
    let base = '';
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasUppercase) {
        base = base + "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    }
    if (opts.hasNumeric) {
        base = base + "0123456789";
    }
    if (opts.hasLowercase && ($random(891) % 7)) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    if (opts.hasSpecials) {
        base = base + "!#$-_&*@()+/";
    }
    if (opts.hasSpecials && ($random(1795) % 3)) {
        base = base + "-#@*!";
    }
    if (opts.hasNumeric && ($random(733) % 2)) {
        base = base + "0123456789";
    }
    if (opts.hasNumeric) {
        base = base + "0123456789";
    }
    if (opts.hasLowercase) {
        base = base + "abcdefghijklmnopqrstuvwxyz";
    }
    const charlen = base.length;
    let identicals = 0, i = 0;
    let last = '', password = '';
    while (i < len) {
        let c = base.charAt($random(charlen));
        if (c == last) {
            if (++identicals == MAX_CONSECUTIVE_CHARS) {
                identicals--;
            }
            else {
                password = password + c;
                i++;
            }
            ;
        }
        else {
            last = c;
            identicals = 0;
            password = password + c;
            i++;
        }
    }
    return password;
}
exports.$password = $password;
Uint8Array.prototype.crc32 = function crc32() { return $crc32(this); };
Uint8Array.prototype.hash = function hash(method) { return $hash(this, method); };
ArrayBuffer.prototype.crc32 = function crc32() { return $crc32(this); };
ArrayBuffer.prototype.hash = function hash(method) { return $hash(this, method); };
//# sourceMappingURL=crypto.js.map