/// <reference types="node" />
import { Bytes, Nullable, TSDataLike, uint8 } from "./types";
export declare function $bufferFromArrayBuffer(a: ArrayBuffer): Buffer;
export declare function $bytesFromBytes(source: Bytes, sourceStart?: Nullable<number>, sourceEnd?: Nullable<number>): uint8[];
export declare function $bufferFromBytes(source: Bytes, sourceStart?: Nullable<number>, sourceEnd?: Nullable<number>): Buffer;
export declare function $uint8ArrayFromBytes(source: Bytes, sourceStart?: Nullable<number>, sourceEnd?: Nullable<number>): Uint8Array;
export declare function $uint8ArrayFromDataLike(source: TSDataLike, sourceStart?: Nullable<number>, sourceEnd?: Nullable<number>): Uint8Array;
export declare function $arrayBufferFromBytes(source: Bytes, sourceStart?: Nullable<number>, sourceEnd?: Nullable<number>): ArrayBuffer;
export declare function $decodeBase64(input: string, reference?: string): Uint8Array;
export declare function $encodeBase64(source: Uint8Array | string, reference?: string): string;
interface $bufferAspectOptions {
    prefix?: string;
    suffix?: string;
    name?: string;
    separator?: string;
    showLength?: boolean;
    transformFn?: (n: number) => string;
}
export declare function $dataAspect(source: Bytes | Uint16Array | Uint32Array, opts?: $bufferAspectOptions): string;
declare global {
    export interface String {
        toBase64: (this: string) => string;
    }
    export interface Uint8Array {
        leafInspect: (this: Uint8Array) => string;
        toBase64: (this: Uint8Array) => string;
    }
    export interface Uint16Array {
        leafInspect: (this: Uint16Array) => string;
    }
    export interface Uint32Array {
        leafInspect: (this: Uint32Array) => string;
    }
    export interface ArrayBuffer {
        leafInspect: (this: any) => string;
        toBase64: (this: any) => string;
    }
}
export {};
