import { TSDate } from "./tsdate";
import { int, Nullable, uint } from "./types";
export declare function $div(a: number, b: number): number;
export declare function $icast(v: number): number;
export declare function $round(v: number, decimalPlaces?: number): number;
export declare function $fpad2(v: number, failedChar?: string): string;
export declare function $fpad3(v: number, failedChar?: string): string;
export declare function $fpad4(v: number, failedChar?: string): string;
export declare function $fpad(v: number, pad: number, failedChar?: string): string;
export interface $unitOptions {
    unitName?: string;
    unit?: string;
    minimalUnit?: number;
    maximalUnit?: number;
    decimalPlaces?: number;
    ignoreZeroDecimals?: boolean;
    ignoreMinimalUnitDecimals?: boolean;
}
export declare function $unit(n: Nullable<number>, opts?: $unitOptions): string;
export declare function $octets(n: Nullable<number>, decimalPlaces?: number): string;
export declare function $meters(n: Nullable<number>, decimalPlaces?: number): string;
declare global {
    export interface Number {
        fpad: (this: number, pad: number, failedChar?: string) => string;
        fpad2: (this: number, failedChar?: string) => string;
        fpad3: (this: number, failedChar?: string) => string;
        fpad4: (this: number, failedChar?: string) => string;
        hexaValue: (this: number) => number;
        isNewLine: (this: number) => boolean;
        isWhiteSpace: (this: number) => boolean;
        isStrictWhiteSpace: (this: number) => boolean;
        meters: (this: number, decimalPlaces?: number) => string;
        octets: (this: number, decimalPlaces?: number) => string;
        round: (this: number, decimalPlaces?: number) => number;
        singular: (this: number) => boolean;
        toDate: (this: number) => Date | null;
        toHex2: (this: number, toLowerCase?: boolean) => string;
        toHex4: (this: number, toLowerCase?: boolean) => string;
        toHex8: (this: number, toLowerCase?: boolean) => string;
        toInt: (this: number, defaultValue?: int) => int;
        toTSDate: (this: number) => TSDate | null;
        toUnsigned: (this: number, defaultValue?: uint) => uint;
        unit: (this: number, opts?: $unitOptions) => string;
    }
}
